'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Radio = require('@material-ui/core/Radio');

var _Radio2 = _interopRequireDefault(_Radio);

var _RadioGroup = require('@material-ui/core/RadioGroup');

var _RadioGroup2 = _interopRequireDefault(_RadioGroup);

var _FormLabel = require('@material-ui/core/FormLabel');

var _FormLabel2 = _interopRequireDefault(_FormLabel);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function RadioGroupWidget(props) {
    var label = props.label,
        title = props.title,
        value = props.value,
        readonly = props.readonly,
        disabled = props.disabled,
        autofocus = props.autofocus,
        onBlur = props.onBlur,
        onFocus = props.onFocus,
        options = props.options,
        schema = props.schema,
        formContext = props.formContext,
        registry = props.registry,
        otherProps = _objectWithoutProperties(props, ['label', 'title', 'value', 'readonly', 'disabled', 'autofocus', 'onBlur', 'onFocus', 'options', 'schema', 'formContext', 'registry']);

    // Generating a unique field name to identify this set of radio buttons


    var name = Math.random().toString();
    var enumOptions = options.enumOptions;
    // checked={checked} has been moved above name={name}, As mentioned in #349;
    // this is a temporary fix for radio button rendering bug in React, facebook/react#7630.


    var handleChange = function handleChange(event, value) {
        return otherProps.onChange(value);
    };

    return _react2.default.createElement(
        _FormControl2.default,
        { component: 'fieldset' },
        _react2.default.createElement(
            _FormLabel2.default,
            { component: 'legend' },
            label || title
        ),
        _react2.default.createElement(
            _RadioGroup2.default,
            _extends({
                classes: {
                    root: 'fd-radio-group'
                },
                value: value + ''
            }, otherProps, {
                onChange: handleChange,
                onBlur: onBlur && function (event) {
                    return onBlur(otherProps.id, event.target.value);
                },
                onFocus: onFocus && function (event) {
                    return onFocus(otherProps.id, event.target.value);
                },
                name: name
            }),
            enumOptions.map(function (option, index) {
                return _react2.default.createElement(_FormControlLabel2.default, {
                    key: index,
                    name: name,
                    disabled: schema.disabled,
                    value: option.value + '',
                    label: option.label + '',
                    control: _react2.default.createElement(_Radio2.default, { checked: option.value == value })
                });
            })
        )
    );
}

RadioGroupWidget.defaultProps = {
    autofocus: false
};

RadioGroupWidget.propTypes = process.env.NODE_ENV !== "production" ? {
    schema: _propTypes2.default.object.isRequired,
    id: _propTypes2.default.string.isRequired,
    options: _propTypes2.default.shape({
        enumOptions: _propTypes2.default.array,
        inline: _propTypes2.default.bool
    }).isRequired,
    value: _propTypes2.default.any,
    required: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    readonly: _propTypes2.default.bool,
    autofocus: _propTypes2.default.bool,
    onChange: _propTypes2.default.func
} : {};

exports.default = RadioGroupWidget;
module.exports = exports['default'];