'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _reactDatepicker = require('react-datepicker');

var _reactDatepicker2 = _interopRequireDefault(_reactDatepicker);

var _moment = require('moment/moment');

var _moment2 = _interopRequireDefault(_moment);

require('react-datepicker/dist/react-datepicker.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MuiDateInput = function (_React$Component) {
    _inherits(MuiDateInput, _React$Component);

    function MuiDateInput() {
        _classCallCheck(this, MuiDateInput);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    MuiDateInput.prototype.render = function render() {
        var props = this.props;

        var value = props.value,
            readonly = props.readonly,
            disabled = props.disabled,
            autofocus = props.autofocus,
            onBlur = props.onBlur,
            onFocus = props.onFocus,
            options = props.options,
            schema = props.schema,
            formContext = props.formContext,
            registry = props.registry,
            onClick = props.onClick,
            inputProps = _objectWithoutProperties(props, ['value', 'readonly', 'disabled', 'autofocus', 'onBlur', 'onFocus', 'options', 'schema', 'formContext', 'registry', 'onClick']);

        return _react2.default.createElement(_TextField2.default, _extends({
            onClick: onClick,
            margin: 'none',
            readOnly: readonly,

            autoFocus: autofocus,
            value: value || ''
        }, inputProps, {
            onBlur: onBlur && function (event) {
                return onBlur(inputProps.id, event.target.value);
            },
            onFocus: onFocus && function (event) {
                return onFocus(inputProps.id, event.target.value);
            },
            disabled: disabled,
            inputProps: {
                style: { width: '100%' }
            },
            fullWidth: true
        }));
    };

    return MuiDateInput;
}(_react2.default.Component);

function ReactDatePicker(props) {
    var value = props.value,
        options = props.options,
        onBlur = props.onBlur,
        onFocus = props.onFocus,
        schema = props.schema,
        readonly = props.readonly,
        inputProps = _objectWithoutProperties(props, ['value', 'options', 'onBlur', 'onFocus', 'schema', 'readonly']);

    var onChange = function onChange(value) {
        var formatted = value ? value.toISOString() : options.emptyValue;

        return props.onChange(formatted);
    };

    var newVal = value === '' ? undefined : typeof value === 'string' ? (0, _moment2.default)(value, [_moment2.default.ISO_8601, 'L'], 'pt-br', true) : value;

    return _react2.default.createElement(_reactDatepicker2.default, {
        customInput: _react2.default.createElement(MuiDateInput, inputProps),
        selected: newVal,
        disabled: schema.disabled || readonly,
        onChange: onChange,
        isClearable: !(schema.disabled || readonly),
        onBlur: onBlur && function () {
            return onBlur(inputProps.id);
        },
        onFocus: onFocus && function () {
            return onFocus(inputProps.id);
        }
    });
}

ReactDatePicker.defaultProps = {
    type: 'text',
    required: false,
    disabled: false,
    readonly: false,
    autofocus: false
};

ReactDatePicker.propTypes = process.env.NODE_ENV !== "production" ? {
    id: _propTypes2.default.string.isRequired,
    placeholder: _propTypes2.default.string,
    value: _propTypes2.default.any,
    required: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    readonly: _propTypes2.default.bool,
    autofocus: _propTypes2.default.bool,
    onChange: _propTypes2.default.func,
    onBlur: _propTypes2.default.func,
    onFocus: _propTypes2.default.func
} : {};

exports.default = ReactDatePicker;
module.exports = exports['default'];